using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//////////////////////////////////////////////////////////////////
//yGh[̈ړɎgpNXz
// Gh[̎̈ړʒu_ɌÄړʒuւ̈ړ
//////////////////////////////////////////////////////////////////
public class DroneController : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //y萔̐ݒzix݌vŕύX\j
    const float MAX_DISTANCE = 22f; // Gh[XZ̍s͈
    const float MAX_HIGH = 7f; // Gh[Y̍s͈


    //ỹvOŎgpPrivateϐz
    private GameObject go_Camera; // ARJ̃Q[IuWFNg
    private GameController cl_GameController; // GameControllerNX

    private Vector3 target_Position; // Gh[̎̈ړʒu
    private float move_Factor; // Gh[̈ړXs[h
    private float speed_Low; // Gh[̈ړXs[h̍ŏl
    private float speed_High; // Gh[̈ړXs[h̍ől


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnStartOɂP񂾂֐z
    //iUnity̕W֐j
    void Awake()
    {
        // Gh[JɌ邽߃J̃IuWFNg擾
        go_Camera = GameObject.FindWithTag("MainCamera");

        // x}X^GameControllerNX擾
        cl_GameController = 
            GameObject.Find("GameManager")
            .GetComponent<GameController>();
    }

    
    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        // Gh[̈ړXs[h̍ŏlƍőlx}X^擾
        speed_Low = cl_GameController.OnGet_LV_Speed_Low();
        speed_High = cl_GameController.OnGet_LV_Speed_High();

        // Gh[̏ʒu肵ĈړF
        // Gh[̏ʒuW_Ɍ
        float pos_X = Random.Range(-MAX_DISTANCE, MAX_DISTANCE);        
        float pos_Y = Random.Range(0f, MAX_HIGH);
        float pos_Z = MAX_DISTANCE;

        // Gh[ʒuɈړ
        transform.position = new Vector3(pos_X, pos_Y, pos_Z);
        // Gh[̌JɌ
        transform.LookAt(go_Camera.transform.position);

        // ړʒǔF
        // ̈ړʒu肷֐Ăяo
        OnReset_TargetPosition();
    }


    //yԊuɂPx֐z
    //iUnity̕W֐j
    void FixedUpdate()
    {
        // Q[~ԂłΓGh[̓sȂ
        if (cl_GameController.Stop_Game) return;

        // Gh[̈ʒuƎ̈ړʒu܂ł̋苗k܂
        if ((target_Position - transform.position).magnitude < 0.05f)
        {
            // ̈ړʒu肷֐Ăяo
            OnReset_TargetPosition();
        }

        // Gh[ړʒuɌāA肵Xs[hňړ
        transform.position = 
            Vector3.MoveTowards(transform.position, 
                target_Position, move_Factor);
        // Gh[̌JɌ
        transform.LookAt(go_Camera.transform.position);
    }


    //yGh[̎̈ړʒu肷֐z
    public void OnReset_TargetPosition()
    {
        // Gh[̎̈ړʒuW_Ɍ
        float pos_X = Random.Range(-MAX_DISTANCE, MAX_DISTANCE);
        float pos_Y = Random.Range(0f, MAX_HIGH);
        float pos_Z = Random.Range(2.5f, MAX_DISTANCE);

        // Gh[̎̈ړʒu
        target_Position = new Vector3(pos_X, pos_Y, pos_Z);
        
        // Gh[̈ړXs[h_Ɍ
        move_Factor = Random.Range(speed_Low, speed_High);
    }
}
