using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using TMPro; // UIeLXgTextMeshProg߂Ɏgp

//////////////////////////////////////////////////////////////////
//yGh[̎ƓGh[̊ǗɎgpNXz
// Gh[V[ɎAV[ɏoGh[̐Ǘ
//////////////////////////////////////////////////////////////////
public class DroneGenerator : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //yUnity EditorIuWFNgւ̃ANZXpϐz
    // GameControllerNX
    [SerializeField] private GameController cl_GameController;
    // Gh[Prefab
    [SerializeField] private GameObject prefab_Drone;

    // Gh[̐eIuWFNg
    [SerializeField] private GameObject go_EnemyOrigin;
    // V[ɏoGh[̐\UIeLXg
    [SerializeField] private TMP_Text text_Enemy;


    //ỹvOŎgpPrivateϐz
    // o̓Gh[̐ij󂳂ĂȂGh[̐j
    private int enemy_Num = 0; 
    private int enemy_Start_Num; // Q[JnɔGh[̐
    private int enemy_MAX_Num; // V[ɔGh[̍ő吔

    private float min_Time_Interval; // G̃_ȔԊu̍ŏl
    private float max_Time_Interval; // G̃_ȔԊu̍ől


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        // Q[JnɃx}X^ɂep[^擾
        // Q[JnɔGh[̐擾
        enemy_Start_Num = cl_GameController.OnGet_LV_Enemy_Start_Num();
        // V[ɔGh[̍ő吔擾
        enemy_MAX_Num = cl_GameController.OnGet_LV_Enemy_MAX_Num();
        
        // G̃_ȔԊu̍ŏlƍől擾
        min_Time_Interval = cl_GameController.OnGet_LV_Min_Time_Interval();
        max_Time_Interval = cl_GameController.OnGet_LV_Max_Time_Interval();

        // Q[JnɃx}X^ɂ鐔Gh[𔭐
        for (int i = 0; i < enemy_Start_Num; i++)
        {
            // Gh[PrefabGh[V[ɐ
            GameObject go_Drone = Instantiate(prefab_Drone);

            // ꂽGh[̃V[ł̐eIuWFNgw
            go_Drone.transform.parent 
                = go_EnemyOrigin.gameObject.transform;

            // oGh[̐P₷
            enemy_Num++;
        }

        // oGh[̐UIɕ\
        text_Enemy.text = enemy_Num.ToString();

        // 莞ԌɓGh[𐶐R[`Ă
        StartCoroutine("OnCreate_Drone");
    }


    //y莞ԌɓGh[̃Q[IuWFNg𐶐R[`z
    IEnumerator OnCreate_Drone()
    {
        // _Ȏԑ҂
        yield return new WaitForSeconds
            (Random.Range(min_Time_Interval, max_Time_Interval));

        // oGh[̃xł̍őoGh[菭Ȃꍇ
        // AQ[~ԂłȂꍇ
        if (enemy_Num < enemy_MAX_Num && !cl_GameController.Stop_Game)
        {
            // Gh[PrefabGh[V[ɐ
            GameObject go_Drone = Instantiate(prefab_Drone);

            // ꂽGh[̃V[ł̐eIuWFNgw
            go_Drone.transform.parent 
                = go_EnemyOrigin.gameObject.transform;

            // oGh[̐P₷
            enemy_Num++;
            // oGh[̐UIɕ\
            text_Enemy.text = enemy_Num.ToString();
        }

        // ēx̃R[`igjĂяo
        StartCoroutine("OnCreate_Drone");
    }


    //yh[j󎞂ɌĂяooGh[̐炷֐z 
    public void OnDecrease_Enemy()
    {
        // oGh[̐P炷
        enemy_Num--;
        // oGh[̐UIɕ\
        text_Enemy.text = enemy_Num.ToString();

        // oGh[̐OɂȂQ[̊֐Ăяo
        if (enemy_Num == 0) cl_GameController.OnGame_Completed();
    }
}
