using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using TMPro; // UIeLXgTextMeshProg߂Ɏgp
using UnityEngine.SceneManagement; // V[̐؂ւɎgp

//////////////////////////////////////////////////////////////////
//yx}X^z
// exŎgpp[^lێ\
//////////////////////////////////////////////////////////////////
[System.Serializable]
public struct LevelSetting
{
    public int level_No; // xԍiݒeՂɂ邽߂̃xԍj
    public int lv_Enemy_Start_Num; // Q[JnɔGh[
    public int lv_Enemy_MAX_Num; // V[ɔGh[̍ő吔
    public int lv_Game_Time; // Q[̏I
    public float lv_Speed_Low; // Gh[̈ړXs[h̍ŏl
    public float lv_Speed_High; // Gh[̈ړXs[h̍ől
    public float lv_Min_Time_Interval; // G̃_ȔԊu̍ŏl
    public float lv_Max_Time_Interval; // G̃_ȔԊu̍ől
}


//////////////////////////////////////////////////////////////////
//yx}X^̕ێƃQ[̑S̓IȊǗɎgpNXz
// x}X^ɊexŎgpp[^lێ
// Q[oߎԂ̊ǗAQ[X^[gEQ[EQ[I[o[
// xǗAꎞ~EX^[gAUI̐Aōx̊Ǘ
//////////////////////////////////////////////////////////////////
public class GameController : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //yUnity EditorIuWFNgւ̃ANZXpϐz
    // exŎgpp[^lێ郌x}X^
    [SerializeField] private LevelSetting[] levelSetting;

    // ݂̃xԍUIeLXgiACRj
    [SerializeField] private TMP_Text text_LV;
    // Q[̎cԂUIeLXg
    [SerializeField] private TMP_Text text_Time;
    // ݂̃xԍUIeLXgiplj
    [SerializeField] private TMP_Text text_Panel_LV;

    // Q[X^[g̃Q[IuWFNg
    [SerializeField] private GameObject go_Text_Start;
    // Q[I[o[̃Q[IuWFNg
    [SerializeField] private GameObject go_Text_GameOver;
    // Q[̃Q[IuWFNg
    [SerializeField] private GameObject go_Text_Completed;
    // xǗpxʂ̃Q[IuWFNg
    [SerializeField] private GameObject go_Panel_LV;


    //yNX̃ANZXpGetterϐz
    private bool stop_Game = false; // Q[̒~ԃtO
    public bool Stop_Game // XNvgANZXvpeB
    {
        get
        {
            return stop_Game;
        }
    }


    //ỹvOŎgpPrivateϐz
    // ݃vC̃xistaticŃV[ēǂݍݎlێj
    private static int level_No = 1;

    private static int max_LV_No = 1; // Bς݂̍ōx

    private bool finish_Game = false; // Q[̏IԃtO
    
    private float play_Time = 0; // Q[̌oߎ
    private int game_Time = 0; // Q[̏I


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        // Bς݂̍ōxfoCX擾
        max_LV_No = PlayerPrefs.GetInt("MAX_LV", 1);

        // ݂̃xԍUIeLXg\
        text_LV.text = level_No.ToString();

        // Q[JnɃx}X^Q[̏IԂ擾
        game_Time = levelSetting[level_No - 1].lv_Game_Time;

        // Q[JnbZ[W\R[`Ă
        StartCoroutine("OnShow_StartMessage");
    }


    //yt[ɂPx֐z
    //iUnity̕W֐j
    void Update()
    {
        // Q[~ԂłΎԂ̌oߏsȂ
        if (stop_Game) return;

        // Q[oߎԂ̃JEg
        play_Time += Time.deltaTime;
        // Q[̎cԂUIeLXg\
        text_Time.text = (game_Time-(int)play_Time).ToString();

        // Q[̎cԂOȉƂȂꍇAQ[I[o[֐Ă
        if ((game_Time - (int)play_Time) <= 0) OnGame_Faild();
    }


    //yQ[JnbZ[W莞Ԍɔ\ɂR[`z
    IEnumerator OnShow_StartMessage()
    {
        // Q[JnbZ[W\
        go_Text_Start.SetActive(true);

        // 莞ԑ҂
        yield return new WaitForSeconds(2f);

        // Q[JnbZ[W\ɂ
        go_Text_Start.SetActive(false);
    }


    //yQ[I[o[̏֐z
    private void OnGame_Faild()
    {
        // Q[IE~Ԃɂ
        finish_Game = true;
        stop_Game = true;

        // Q[I[o[UIeLXg\
        go_Text_GameOver.SetActive(true);
    }


    //yQ[̏֐z
    public void OnGame_Completed()
    {
        // Q[IE~Ԃɂ
        finish_Game = true;
        stop_Game = true;

        // Q[CompletedUIeLXg\
        go_Text_Completed.SetActive(true);

        // xx}X^ɂōx菬ꍇ
        if (level_No < levelSetting.Length)
        {
            // xBς݂̍ōxƓꍇ
            if (level_No == max_LV_No) 
            {
                // Bς݂̍ōxP₷
                max_LV_No++;
                // Bς݂̍ōxfoCXɕۑ
                PlayerPrefs.SetInt("MAX_LV", max_LV_No);
            }

            // ݃vC̃xP₷
            level_No++; 
        }
    }


    //yX^[g{^̏֐z
    public void OnClick_Reset()
    {
        // V[Čďo
        SceneManager.LoadScene("GameMain");
    }


    //yꎞ~{^̏֐z
    public void OnClick_StopGame()
    {
        // Q[Ăꍇ͈ȉ̏sȂ
        if (finish_Game) return;

        // Q[ꎞ~Ăꍇ͈ꎞ~
        if (stop_Game) stop_Game = false;
        // Q[ꎞ~ĂȂꍇ͈ꎞ~
        else stop_Game = true;
    }


    //yx{^̏֐z
    public void OnClick_Level()
    {
        // xʂ\ĂꍇAxʂ\ɂ
        if (go_Panel_LV.activeSelf)
        {
            go_Panel_LV.SetActive(false);
            stop_Game = false;
        }
        // xʂ\ĂȂꍇAxʂ\
        else
        {
            go_Panel_LV.SetActive(true);
            stop_Game = true;
        }

        // xʂɌ݂̃xԍUIeLXg\
        text_Panel_LV.text = level_No.ToString();
    }


    //yxʂ̍{^̏֐z
    public void OnClick_Left()
    {
        // ݂̃xP傫ꍇ́AxP炷
        if (level_No > 1) level_No--;

        // xʂɌ݂̃xԍUIeLXg\
        text_Panel_LV.text = level_No.ToString();
    }


    //yxʂ̉E{^̏֐z
    public void OnClick_Right()
    {
        // ݂̃xBς݂̍ōx菬ꍇ́A
        // xP₷
        if (level_No < max_LV_No) level_No++;

        // xʂɌ݂̃xԍUIeLXg\
        text_Panel_LV.text = level_No.ToString();
    }


    //yBςݍōx̃Zbg{^̏֐z
    public void OnClick_ResetMaxLevel()
    {
        // Bς݂̍ōxPƂăfoCXɕۑ
        PlayerPrefs.SetInt("MAX_LV", 1);

        // ݂̃xƒBςݍōxPɂ
        level_No = 1;
        max_LV_No = 1;

        // X^[g֐Ă
        OnClick_Reset();
    }


    //yx́uQ[JnɔGh[v擾p֐z
    //ix}X^̐ݒl̎擾p֐j
    public int OnGet_LV_Enemy_Start_Num()
    {
        return levelSetting[level_No - 1].lv_Enemy_Start_Num;
    }


    //yx́uV[ɔGh[̍ő吔v擾p֐z
    //ix}X^̐ݒl̎擾p֐j
    public int OnGet_LV_Enemy_MAX_Num()
    {
        return levelSetting[level_No - 1].lv_Enemy_MAX_Num;
    }


    //yx́uGh[̈ړXs[h̍ŏlv擾p֐z
    //ix}X^̐ݒl̎擾p֐j
    public float OnGet_LV_Speed_Low()
    {
        return levelSetting[level_No - 1].lv_Speed_Low;
    }


    //yx́uGh[̈ړXs[h̍őlv擾p֐z
    //ix}X^̐ݒl̎擾p֐j
    public float OnGet_LV_Speed_High()
    {
        return levelSetting[level_No - 1].lv_Speed_High;
    }


    //yx́uG̃_ȔԊu̍ŏlv擾p֐z
    //ix}X^̐ݒl̎擾p֐j
    public float OnGet_LV_Min_Time_Interval()
    {
        return levelSetting[level_No - 1].lv_Min_Time_Interval;
    }


    //yx́uG̃_ȔԊu̍őlv擾p֐z
    //ix}X^̐ݒl̎擾p֐j
    public float OnGet_LV_Max_Time_Interval()
    {
        return levelSetting[level_No - 1].lv_Max_Time_Interval;
    }
}
